<script>
export default {
  name: "ContentPageParagraphVideo",
  props: {
    content: {
      type: Object,
      default () {
        return {};
      }
    }
  },
  data () {
    return {
      ratioComparison: [
        {
          ratioValue: 2.33333,
          ratioClass: "embed-responsive-21by9"
        },
        {
          ratioValue: 1.77778,
          ratioClass: "embed-responsive-16by9"
        },
        {
          ratioValue: 1.33333,
          ratioClass: "embed-responsive-4by3"
        },
        {
          ratioValue: 1.00000,
          ratioClass: "embed-responsive-1by1"
        }
      ]
    };
  },
  computed: {
    ratio_class () {
      const matches = this.content.field_video.match(/.*?width="(\d+?)".*?height="(\d+?)"/i),
        width = !isNaN(parseInt(matches[1], 10)) ? parseInt(matches[1], 10) : 16,
        height = !isNaN(parseInt(matches[2], 10)) ? parseInt(matches[2], 10) : 9,
        ratio = width / height;
      let ratioDiffs = [];

      this.ratioComparison.forEach((item, index) => {
        ratioDiffs[index] = [index, Math.abs(item.ratioValue - ratio)];
      });

      ratioDiffs.sort((a, b) => {
        return a[1] > b[1] ? 1 : -1;
      });

      return this.ratioComparison[ratioDiffs[0][0]].ratioClass;
    }
  }
};
</script>

<template>
  <div
    class="ContentPageParagraphVideo embed-responsive"
    :class="ratio_class"
    v-html="content.field_video"
  />
</template>

<style lang="scss">
div.ContentPageParagraphVideo {
  margin-top: 10px;
  margin-bottom: 10px;

  iframe {
    border: 1px solid #707070;
  }
}
</style>
